(function(global,factory){typeof exports==="object"&&typeof module!=="undefined"?module.exports=factory(require("resource-manager-js")):typeof define==="function"&&define.amd?define(["resource-manager-js"],factory):global["YoutubeVideo "]=factory(global.ResourceManager)})(this,function(ResourceManager){"use strict";ResourceManager=ResourceManager&&ResourceManager.hasOwnProperty("default")?ResourceManager["default"]:ResourceManager;let eventMethodMap={};let players=new Map;let scriptPath="https://www.youtube.com/iframe_api";let videoCount=0;let getPlayerVars=function(sourceUrl){var queryString=sourceUrl.split("?")[1]||"",a=queryString.split("&");if(a=="")return{};var b={};for(var i=0;i<a.length;++i){var p=a[i].split("=",2);if(p.length==1)b[p[0]]="";else b[p[0]]=decodeURIComponent(p[1].replace(/\+/g," "))}return b};class YoutubeVideo{constructor(options){var el=options.el||document.createDocumentFragment();this.options=Object.assign({el:el,autoplay:el.getAttribute("autoplay"),width:el.getAttribute("width"),forceSSL:false,height:el.getAttribute("height"),playingCssClass:"video-playing",loadingCssClass:"video-loading",customWrapperClass:"video-wrapper"},options);videoCount++;this.el=this.options.el;let privateProps={id:videoCount,origParent:this.el.parentNode};eventMethodMap={ended:this._onEnd,playing:this._onPlay,pause:this._onPause};privateProps.playerVars=Object.assign({autoplay:this.options.autoplay?1:0,forceSSL:this.options.forceSSL},getPlayerVars(this.sourceUrl));players.set(this,privateProps);this.el.play=(()=>this._play());this.el.pause=(()=>this._pause());this.el.load=(()=>this._load())}get sourceUrl(){var sources=this.el.getElementsByTagName("source"),i,count=sources.length,source;if(!this.src){for(i=0;i<count;i++){source=sources[i];if(source.getAttribute("type")==="video/youtube"){this.src=source.getAttribute("src");break}}this.src=this.src||""}return this.src}async _load(){let instance=players.get(this);let container=document.createElement("div");let origParent=players.get(this).origParent;container.setAttribute("class",this.options.customWrapperClass);instance.container=container;if(origParent&&origParent.contains(this.el)){origParent.replaceChild(container,this.el)}container.appendChild(this.el);this.options.el.style.position="absolute";this.options.el.style.zIndex="-1";container.classList.add(this.options.loadingCssClass);this.el.dispatchEvent(new CustomEvent("loadstart"));await this._loadScript();this.ytPlayer=await this._buildPlayer();container.classList.remove(this.options.loadingCssClass);return this.ytPlayer}getVideoId(url){var re=/https?:\/\/(?:[0-9A-Z-]+\.)?(?:youtu\.be\/|youtube(?:-nocookie)?\.com\S*[^\w\s-])([\w-]{11})(?=[^\w-]|$)(?![?=&+%\w.-]*(?:['"][^<>]*>|<\/a>))[?=&+%\w.-]*/gi;return url.replace(re,"$1")}_play(){if(!this.sourceUrl){console.warn("youtube video error: you cannot call play() method on a video element that has no youtube source url")}else if(this.ytPlayer){this.ytPlayer.playVideo()}}_pause(){this.ytPlayer?this.ytPlayer.pauseVideo():null}_stop(){this.ytPlayer?this.ytPlayer.stopVideo():null}_loadScript(){if(!YoutubeVideo.prototype._scriptLoadPromise){YoutubeVideo.prototype._scriptLoadPromise=new Promise(resolve=>{if(!window.onYouTubeIframeAPIReady){YoutubeVideo.prototype._triggerYoutubeIframeAPIReady=resolve;window.onYouTubeIframeAPIReady=(()=>{window.onYouTubeIframeAPIReady=null;YoutubeVideo.prototype._triggerYoutubeIframeAPIReady()})}return ResourceManager.loadScript(scriptPath)})}return YoutubeVideo.prototype._scriptLoadPromise}_unloadScript(){ResourceManager.unloadScript(scriptPath);YoutubeVideo.prototype._scriptLoadPromise=null}async _buildPlayer(){let instance=players.get(this)||{};if(instance.ytPlayer){return Promise.resolve(instance.ytPlayer)}let id="vplayer"+instance.id;let ytEl=this.createPlayerElement();ytEl.setAttribute("id",id);instance.container.appendChild(ytEl);this.videoId=this.getVideoId(this.sourceUrl);return new Promise(resolve=>{instance.ytPlayer=new YT.Player(ytEl,{height:this.options.height,width:this.options.width,playerVars:instance.playerVars,videoId:this.videoId,events:{onReady:e=>{this.el.dispatchEvent(new CustomEvent("canplay"));this._resolveBuildPlayerPromise=resolve;resolve(e.target)},onStateChange:obj=>{this._onYTApiStateChange(obj)}}})})}createPlayerElement(){return document.createElement("div")}_onPlay(){let instance=players.get(this);players.forEach(playerInstance=>{if(playerInstance!==instance&&playerInstance.ytPlayer.getPlayerState()===1){const videoElement=playerInstance.container.querySelector("video");videoElement.pause()}});instance.container.classList.add(this.options.playingCssClass);this.el.dispatchEvent(new CustomEvent("play"))}_onPause(){let container=players.get(this).container;container.classList.remove(this.options.playingCssClass)}_onEnd(){let container=players.get(this).container;container.classList.remove(this.options.playingCssClass)}_onYTApiStateChange(obj){let stateMap={"-1":"unstarted",0:"ended",1:"playing",2:"pause",3:"buffering",5:"cued"};let state=stateMap[obj.data.toString()];if(eventMethodMap[state]){let method=eventMethodMap[state];if(method){method.call(this);this.el.dispatchEvent(new CustomEvent(state))}}}destroy(){let instance=players.get(this);let container=instance.container;let origParent=instance.origParent;if(container){container.classList.remove(this.options.loadingCssClass)}players.delete(this);if(!players.size){players.clear();videoCount=0;this._unloadScript()}eventMethodMap={};if(this._resolveBuildPlayerPromise){this._resolveBuildPlayerPromise()}if(origParent&&origParent.contains(container)){origParent.replaceChild(this.el,container)}}}return YoutubeVideo});